<cfsetting enablecfoutputonly="yes" />
<!---
==========================================================================
Planning SA ( http://www.planning.sa.gov.au )
==========================================================================
|| APPLICATION ||
Application: Atlas of South Australia

|| LEGAL ||                             
Copyright Planning SA, Primary Industries and Resources.  
All Rights Reserved.  All works and information displayed are subject to copyright.  For 
the reproduction or publication beyond that permitted by the Copyright Act 1968 (Cwlth) 
written permission must be sought from the Department. 

Although every effort has been made to ensure the accuracy of the information displayed, 
the Department, its agents, officers and employees make no representations, either express 
or implied, that the information displayed is accurate or fit for any purpose and expressly 
disclaims all liability for loss or damage arising from reliance upon the information displayed.

|| VERSION CONTROL ||
$Date: 2005-12-21 12:29:50 +1030 (Wed, 21 Dec 2005) $
$Author: whiterd $
$Revision: 112 $
$Id: _bjmenu.cfm 112 2005-12-21 01:59:50Z whiterd $

|| DESCRIPTION || 
$Description$

--->
<!--- @@displayname: Brain Jar Menu --->
<!--- @@author: Original Chris Kent; xCode fixes Jeff Coughlin; David Whiterod (whiterod.david@saugov.sa.gov.au) --->

<!---
*** Recent changes ***

20051221 Uses ObjectID (instead of objectName) as the ID of the submenus. This allows duplicate folder names and removed the need to clean non-XHTML characters from the menu name
--->

<cffunction name="safeFormatString" output="false" returnType="string">
	<cfargument name="sString" type="string" required="true">
	<cfscript>
		var sResult = "";
		sResult = XMLFormat(Trim(sString));
		// &apos; is not a valid HTML entity reference (see: http://fishbowl.pastiche.org/2003/07/01/the_curse_of_apos)
		sResult = ReplaceNoCase(sResult,"&apos;", "&##39;", "ALL");
		//sResult = Replace(sResult, " ", "&nbsp;", "ALL");
	</cfscript>
	<cfreturn sResult>
</cffunction>

<cfparam name="attributes.startNavID" default="#application.navid.home#">
<cfparam name="attributes.includeHomeLink" default="true">
<cfparam name="attributes.includeDiv" default="true">
<cfimport taglib="/farcry/farcry_core/tags/webskin" prefix="skin">
<!--- Get First Level Menu Items for menu bar --->
<cfscript>
	navFilter=arrayNew(1);
	navfilter[1]="status IN (#listQualify(request.mode.lvalidstatus, "'")#)";
	qNav = application.factory.oTree.getDescendants(objectid=attributes.startNavID, depth=1, afilter=navFilter);
//	qNav = application.factory.oTree.getDescendants(objectid=attributes.startNavID, depth=1);
</cfscript>
<!--- <cfset qNav = application.factory.oTree.getChildren(objectID=#attributes.startNavID#)> --->

<!--- Container Div for brainjar menu --->
<cfoutput><div class="menuBar" style="width:98%;"></cfoutput>
<!--- <cfoutput><div class="menuBar"></cfoutput> --->
<!--- Create top-level menu bar buttons --->
<cfif attributes.includeHomeLink>
	<skin:buildLink objectid="#application.navid.home#" class="menuButton"><cfoutput>Home</cfoutput></skin:buildLink>
</cfif>
<cfloop query="qNav">
	<!--- check to see if each top-level node has any descendants. Extra queries but fixes JavaScript error when no child menus are avaiable --->
	<cfscript>
		qNav2 = application.factory.oTree.getDescendants(objectID=qNav.objectID, depth="1");
		//variables.blrunjavascript = 0;
		if (qNav2.recordcount gt 0){
			//variables.blrunjavascript = 1;
			xCode = 'onmouseover="buttonMouseover(event, ''menu#qNav.ObjectID#'');"';
		}else{
			xCode = "";
		}
	</cfscript>
	<skin:buildLink objectid="#qNav.objectid#" class="menuButton" xCode="#xCode#" bShowTarget="0"><cfoutput>#safeFormatString(qNav.objectName)#</cfoutput></skin:buildLink>
</cfloop>
<cfoutput></div></cfoutput>

<!--- Parse all nodes in tree --->
<cfset qNav = application.factory.oTree.getDescendants(objectID=attributes.startNavID, afilter=navFilter)>
<!--- <cfdump var="#qNav#"> --->
<cfloop query="qNav">
	<!--- Get children if any --->
	<cfscript>
		qNav2 = application.factory.oTree.getDescendants(objectid=qNav.objectID, depth=1, afilter=navFilter);
	</cfscript>
	<!--- <cfset qNav2 = application.factory.oTree.getChildren(objectID=qNav.objectID)> ---><!--- <cfdump var="#qNav2#"> --->

	<!--- Create a sub menu --->
	<cfif qNav2.recordcount gt 0>
		<cfoutput><div id="menu#qNav.ObjectID#" class="menu" onmouseover="menuMouseover(event)"></cfoutput>
			<!--- Create sub menu children --->
			<cfloop query="qNav2">
			<!--- <cfset qNav3 = application.factory.oTree.getChildren(objectID=qNav2.objectID)> --->
			<!--- TODO retro fit this switch to getdescendants - will stop the showing of the arrow indicating a submenu if that submenu is not approved	--->
			<cfscript>
				qNav3 = application.factory.oTree.getDescendants(objectid=qNav2.objectID, depth=1, afilter=navFilter);
			</cfscript>
			<!--- Is there another submenu below this link? --->
				<cfif qNav3.recordcount gt 0>
					<cfoutput><a class="menuItem" href="</cfoutput><skin:buildLink urlOnly="true" objectid="#qNav2.objectid#"></skin:buildLink><cfoutput>" onmouseover="menuItemMouseover(event, 'menu#qNav2.ObjectID#');"><span class="menuItemText">#safeFormatString(qNav2.objectName)#</span><span class="menuItemArrow">&##9654;</span></a></cfoutput>
				<cfelse>
					<cfoutput><a class="menuItem" href="</cfoutput><skin:buildLink urlOnly="true" objectid="#qNav2.objectid#"></skin:buildLink><cfoutput>"><span class="menuItemText">#safeFormatString(qNav2.objectName)#</span></a></cfoutput>
				</cfif>
			</cfloop>
		<cfoutput></div></cfoutput>
	</cfif>
</cfloop>
<cfsetting enablecfoutputonly="no" />